searchNodes=[{"doc":"An unofficial Elixir SDK for the Philips Hue personal wireless lightning system. Build with Finch , Jason , Mdns , and NimbleOptions . Features HueSDK ships with the following features: Automatic discovery of the Hue Bridge device on local networks Complete support of the latest Hue Bridge JSON REST API SSL support for requests made to the Hue Bridge device Automatic Bridge Discovery HueSDK supports automatic bridge discovery via the following protocols: N-UPnP mDNS Manual IP If you have already connected your Hue Bridge device to the internet and registered online with Philips, then N-UPnP will be the fastest and most reliable way to discover your device. If you do not wish to connect your Hue Bridge device to the internet or register it with Philips, then mDNS can be used to discover your device. If neither of those protocols work, you can manually enter the IP address of your Hue Bridge device via the Manual IP protocol. Consult your home router to identify the device's IP address. REST API HueSDK supports the following resources: Lights Groups Schedules Scenes Sensors Rules Configuration Resourcelinks Capabilities Currently, this library provides a simple Elixir wrapper over the Hue Bridge REST API. Please refer to the official documentation for detailed information on interacting with lights, groups, schedules, etc. High-level Elixir APIs may be added in future versions. If you have any you would like implemented, please open an issue or pull-request! Installation Add the Hue SDK to your mix.exs and run mix deps.get : def deps do [ { :hue_sdk , &quot;~&gt; 0.1.0&quot; } ] end Add any optional configuration to your config/*.exs files: use Config # disabling SSL config :hue_sdk , ssl : false # specifying a custom N-UPnP host config :hue_sdk , portal_host : &quot;mycustomproxy.com&quot; Usage Automatically discover your Hue Bridge device available on your local network: { :nupnp , [ bridge ] } = HueSDK.Discovery . discover ( HueSDK.Discovery.NUPNP ) Press the link button on your Hue Bridge device and authenticate a new user: bridge = HueSDK.Bridge . authenticate ( bridge , &quot;connorlay#huesdk&quot; ) Make requests to the Hue Bridge REST API: HueSDK.API.Lights . get_all_lights ( bridge ) { :ok , %{ &quot;1&quot; =&gt; %{ &quot;capabilities&quot; =&gt; %{ &quot;certified&quot; =&gt; true , &quot;control&quot; =&gt; %{ &quot;colorgamut&quot; =&gt; [ [ 0.6915 , 0.3083 ] , [ 0.17 , 0.7 ] , [ 0.1532 , 0.0475 ] ] , &quot;colorgamuttype&quot; =&gt; &quot;C&quot; , &quot;ct&quot; =&gt; %{ &quot;max&quot; =&gt; 500 , &quot;min&quot; =&gt; 153 } , &quot;maxlumen&quot; =&gt; 800 , &quot;mindimlevel&quot; =&gt; 200 } , &quot;streaming&quot; =&gt; %{ &quot;proxy&quot; =&gt; true , &quot;renderer&quot; =&gt; true } } , &quot;config&quot; =&gt; %{ &quot;archetype&quot; =&gt; &quot;classicbulb&quot; , &quot;direction&quot; =&gt; &quot;omnidirectional&quot; , &quot;function&quot; =&gt; &quot;mixed&quot; , &quot;startup&quot; =&gt; %{ &quot;configured&quot; =&gt; true , &quot;mode&quot; =&gt; &quot;safety&quot; } } , &quot;manufacturername&quot; =&gt; &quot;Signify Netherlands B.V.&quot; , &quot;modelid&quot; =&gt; &quot;LCA003&quot; , &quot;name&quot; =&gt; &quot;Floor Lamp&quot; , &quot;productid&quot; =&gt; &quot;Philips-LCA003-1-A19ECLv6&quot; , &quot;productname&quot; =&gt; &quot;Hue color Lamp&quot; , &quot;state&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;select&quot; , &quot;bri&quot; =&gt; 145 , &quot;colormode&quot; =&gt; &quot;xy&quot; , &quot;ct&quot; =&gt; 443 , &quot;effect&quot; =&gt; &quot;none&quot; , &quot;hue&quot; =&gt; 7675 , &quot;mode&quot; =&gt; &quot;homeautomation&quot; , &quot;on&quot; =&gt; false , &quot;reachable&quot; =&gt; true , &quot;sat&quot; =&gt; 199 , &quot;xy&quot; =&gt; [ 0.5016 , 0.4151 ] } , &quot;swconfigid&quot; =&gt; &quot;598716A0&quot; , &quot;swupdate&quot; =&gt; %{ &quot;lastinstall&quot; =&gt; &quot;2021-01-27T22:48:41&quot; , &quot;state&quot; =&gt; &quot;noupdates&quot; } , &quot;swversion&quot; =&gt; &quot;1.76.6&quot; , &quot;type&quot; =&gt; &quot;Extended color light&quot; , &quot;uniqueid&quot; =&gt; &quot;00:17:88:01:09:4c:a7:29-0b&quot; } , # ... } }","ref":"HueSDK.html","title":"HueSDK","type":"module"},{"doc":"Interface to the Hue Bridge device, required to call functions in the HueSDK.API namespace.","ref":"HueSDK.Bridge.html","title":"HueSDK.Bridge","type":"module"},{"doc":"Authenticates a new devicetype/0 with the Hue Bridge REST API. For authentication to succeed, the link button on the Hue Bridge device must be pressed within 30 seconds of invoking this function. Examples HueSDK.Bridge . authenticate ( bridge , &quot;connorlay#huesdk&quot; ) % HueSDK.Bridge { username : &quot;Ht-Flaev-p7Vk5ryJinxKwlYdQupdEXL4c5lKLXL&quot; , # ... }","ref":"HueSDK.Bridge.html#authenticate/2","title":"HueSDK.Bridge.authenticate/2","type":"function"},{"doc":"A unique identifier to register with the Hue Bridge API. Examples &quot;connorlay#huesdk&quot;","ref":"HueSDK.Bridge.html#t:devicetype/0","title":"HueSDK.Bridge.devicetype/0","type":"type"},{"doc":"Stateless struct containing Hue Bridge device information. Examples % HueSDK.Bridge { api_version : &quot;1.42.0&quot; , bridge_id : &quot;EGB5FAFAFE196528&quot; , datastore_version : &quot;99&quot; , host : &quot;192.168.1.2&quot; , mac : &quot;f0:dd:e5:1f:38:cd&quot; , model_id : &quot;BSB002&quot; , name : &quot;My Hue Bridge&quot; , sw_version : &quot;1943082030&quot; , username : &quot;Ht-Flaev-p7Vk5ryJinxKwlYdQupdEXL4c5lKLXL&quot; }","ref":"HueSDK.Bridge.html#t:t/0","title":"HueSDK.Bridge.t/0","type":"type"},{"doc":"Application configuration available for HueSDK .","ref":"HueSDK.Config.html","title":"HueSDK.Config","type":"module"},{"doc":"The DNS host of the Hue Bridge discovery portal. Defaults to discovery.meethue.com . Examples Configuring a custom host for HueSDK.Discovery.NUPNP requests: config :hue_sdk , portal_host : &quot;discovery.meethue.com&quot;","ref":"HueSDK.Config.html#portal_host/0","title":"HueSDK.Config.portal_host/0","type":"function"},{"doc":"Should SSL be used for requests made to the Hue Bridge? Defaults to true . Hue Bridge SSL certificates are self-signed. The first certificate received will be pinned and used to verify subsequent responses. Examples Enabling SSL for all requests made to the Hue Bridge: config :hue_sdk , ssl : true Disabling SSL for all requests made to the Hue Bridge: config :hue_sdk , ssl : false","ref":"HueSDK.Config.html#ssl?/0","title":"HueSDK.Config.ssl?/0","type":"function"},{"doc":"HTTP client used for all requests made by the HueSDK . Utilizes Finch and for requests and connection pooling.","ref":"HueSDK.HTTP.html","title":"HueSDK.HTTP","type":"module"},{"doc":"Decoded HTTP response, usually a map/0 or list/0 . See Mint.Types.error/0 for error information.","ref":"HueSDK.HTTP.html#t:response/0","title":"HueSDK.HTTP.response/0","type":"type"},{"doc":"Automatic discovery of Hue Bridge devices available on the local network. See HueSDK.Discovery.discover/2 for examples.","ref":"HueSDK.Discovery.html","title":"HueSDK.Discovery","type":"behaviour"},{"doc":"Attempts to discover all available Hue Bridge devices on the local network. Examples Discovering a Hue Bridge device via the discovery portal URL: HueSDK.Discovery . discover ( HueSDK.Discovery.NUPNP ) { :nupnp , [ % HueSDK.Bridge { } ] } Discovering a Hue Bridge device via multicast DNS: HueSDK.Discovery . discover ( HueSDK.Discovery.MDNS ) { :mdns , [ % HueSDK.Bridge { } ] } Discovering a Hue Bridge device via a manually supplied IP address : HueSDK.Discovery . discover ( HueSDK.Discovery.ManualIP , ip_address : &quot;127.0.0.1&quot; ) { :manual_ip , [ % HueSDK.Bridge { } ] } An empty list is returned if no Hue Bridge devices are found: HueSDK.Discovery . discover ( HueSDK.Discovery.ManualIP , ip_address : &quot;000.0.0.0&quot; ) { :mdns , [ ] } If invalid options are given, a NimbleOptions.ValidationError is raised: HueSDK.Discovery . discover ( HueSDK.Discovery.ManualIP , invalid_opt : :invalid_opt ) ** (NimbleOptions.ValidationError) unknown options [:invalid_opt], valid options are: [:ip_address, :mdns_namespace, :max_attempts, :sleep] Options :ip_address - The IP address of the Hue Bridge, required for manual discovery. :mdns_namespace - The multicast DNS namespace to query. The default value is &quot;_hue._tcp.local&quot; . :max_attempts - How many discovery attempts are made before giving up. The default value is 10 . :sleep - How long to wait in miliseconds between each attempt. The default value is 5000 .","ref":"HueSDK.Discovery.html#discover/2","title":"HueSDK.Discovery.discover/2","type":"function"},{"doc":"Attempts to discover all available Hue Bridge devices on the local network. See HueSDK.Discovery.discover/2 for more information.","ref":"HueSDK.Discovery.html#c:do_discovery/1","title":"HueSDK.Discovery.do_discovery/1","type":"callback"},{"doc":"A list of discovered Hue Bridge devices, tagged by the discovery strategy.","ref":"HueSDK.Discovery.html#t:discovery_result/0","title":"HueSDK.Discovery.discovery_result/0","type":"type"},{"doc":"mDNS discovery of the Hue Bridge. See HueSDK.Discovery for available options.","ref":"HueSDK.Discovery.MDNS.html","title":"HueSDK.Discovery.MDNS","type":"module"},{"doc":"Manual IP discovery of the Hue Bridge. See HueSDK.Discovery for available options.","ref":"HueSDK.Discovery.ManualIP.html","title":"HueSDK.Discovery.ManualIP","type":"module"},{"doc":"N-UPnP discovery of the Hue Bridge. Requires a Hue Bridge registered with the official Philips Hue Discovery Portal. See HueSDK.Discovery for available options.","ref":"HueSDK.Discovery.NUPNP.html","title":"HueSDK.Discovery.NUPNP","type":"module"},{"doc":"Interface to the Hue Bridge Capabilities API. See the official documentation for more information.","ref":"HueSDK.API.Capabilities.html","title":"HueSDK.API.Capabilities","type":"module"},{"doc":"Allows the user to list capabilities of resources supported in the bridge.","ref":"HueSDK.API.Capabilities.html#get_all_capabilities/1","title":"HueSDK.API.Capabilities.get_all_capabilities/1","type":"function"},{"doc":"Interface to the Configuration API. See the official documentation for more information.","ref":"HueSDK.API.Configuration.html","title":"HueSDK.API.Configuration","type":"module"},{"doc":"Creates a new user. The link button on the bridge must be pressed and this command executed within 30 seconds. Once a new user has been created, the user key is added to a ‘whitelist’, allowing access to API commands that require a whitelisted user. At present, all other API commands require a whitelisted user.","ref":"HueSDK.API.Configuration.html#create_user/2","title":"HueSDK.API.Configuration.create_user/2","type":"function"},{"doc":"Returns list of all configuration elements in the bridge. Note all times are stored in UTC.","ref":"HueSDK.API.Configuration.html#get_bridge_config/1","title":"HueSDK.API.Configuration.get_bridge_config/1","type":"function"},{"doc":"This command is used to fetch the entire datastore from the device, including settings and state information for lights, groups, schedules and configuration. It should only be used sparingly as it is resource intensive for the bridge, but is supplied e.g. for synchronization purposes.","ref":"HueSDK.API.Configuration.html#get_bridge_datastore/1","title":"HueSDK.API.Configuration.get_bridge_datastore/1","type":"function"},{"doc":"Allows the user to set some configuration values.","ref":"HueSDK.API.Configuration.html#modify_bridge_config/2","title":"HueSDK.API.Configuration.modify_bridge_config/2","type":"function"},{"doc":"Interface to the Groups API. See the official documentation for more information.","ref":"HueSDK.API.Groups.html","title":"HueSDK.API.Groups","type":"module"},{"doc":"Creates a new group containing the lights specified and optional name. A new group is created in the bridge with the next available id.","ref":"HueSDK.API.Groups.html#create_group/4","title":"HueSDK.API.Groups.create_group/4","type":"function"},{"doc":"Deletes the specified group from the bridge.","ref":"HueSDK.API.Groups.html#delete_group/2","title":"HueSDK.API.Groups.delete_group/2","type":"function"},{"doc":"Gets a list of all groups that have been added to the bridge. A group is a list of lights that can be created, modified and deleted by a user.","ref":"HueSDK.API.Groups.html#get_all_groups/1","title":"HueSDK.API.Groups.get_all_groups/1","type":"function"},{"doc":"Gets the group attributes, e.g. name, light membership and last command for a given group.","ref":"HueSDK.API.Groups.html#get_group_attributes/2","title":"HueSDK.API.Groups.get_group_attributes/2","type":"function"},{"doc":"Allows the user to modify the name, light and class membership of a group.","ref":"HueSDK.API.Groups.html#set_group_attributes/3","title":"HueSDK.API.Groups.set_group_attributes/3","type":"function"},{"doc":"Modifies the state of all lights in a group.","ref":"HueSDK.API.Groups.html#set_group_state/3","title":"HueSDK.API.Groups.set_group_state/3","type":"function"},{"doc":"Interface to the Lights API. See the official documentation for more information.","ref":"HueSDK.API.Lights.html","title":"HueSDK.API.Lights","type":"module"},{"doc":"Deletes a light from the bridge.","ref":"HueSDK.API.Lights.html#delete_light/2","title":"HueSDK.API.Lights.delete_light/2","type":"function"},{"doc":"Gets a list of all lights that have been discovered by the bridge.","ref":"HueSDK.API.Lights.html#get_all_lights/1","title":"HueSDK.API.Lights.get_all_lights/1","type":"function"},{"doc":"Gets the attributes and state of a given light.","ref":"HueSDK.API.Lights.html#get_light_attributes_and_state/2","title":"HueSDK.API.Lights.get_light_attributes_and_state/2","type":"function"},{"doc":"Gets a list of lights that were discovered the last time a search for new lights was performed. The list of new lights is always deleted when a new search is started.","ref":"HueSDK.API.Lights.html#get_new_lights/1","title":"HueSDK.API.Lights.get_new_lights/1","type":"function"},{"doc":"Starts searching for new lights. The bridge will open the network for 40s. The overall search might take longer since the configuration of (multiple) new devices can take longer. If many devices are found the command will have to be issued a second time after discovery time has elapsed. If the command is received again during search the search will continue for at least an additional 40s. When the search has finished, new lights will be available using the get new lights command. In addition, the new lights will now be available by calling get all lights or by calling get group attributes on group 0. Group 0 is a special group that cannot be deleted and will always contain all lights known by the bridge.","ref":"HueSDK.API.Lights.html#search_for_new_lights/1","title":"HueSDK.API.Lights.search_for_new_lights/1","type":"function"},{"doc":"Used to rename lights. A light can have its name changed when in any state, including when it is unreachable or off.","ref":"HueSDK.API.Lights.html#set_light_name/3","title":"HueSDK.API.Lights.set_light_name/3","type":"function"},{"doc":"Allows the user to turn the light on and off, modify the hue and effects.","ref":"HueSDK.API.Lights.html#set_light_state/3","title":"HueSDK.API.Lights.set_light_state/3","type":"function"},{"doc":"Interface to the Resourcelinks API. See the official documentation for more information.","ref":"HueSDK.API.Resourcelinks.html","title":"HueSDK.API.Resourcelinks","type":"module"},{"doc":"Creates a new resourcelink in the bridge and generates a unique identifier for this resourcelink.","ref":"HueSDK.API.Resourcelinks.html#create_resourcelink/2","title":"HueSDK.API.Resourcelinks.create_resourcelink/2","type":"function"},{"doc":"Deletes the specified resourcelink from the bridge.","ref":"HueSDK.API.Resourcelinks.html#delete_resourcelink/2","title":"HueSDK.API.Resourcelinks.delete_resourcelink/2","type":"function"},{"doc":"Gets a list of all resourcelinks that are in the bridge.","ref":"HueSDK.API.Resourcelinks.html#get_all_resourcelinks/1","title":"HueSDK.API.Resourcelinks.get_all_resourcelinks/1","type":"function"},{"doc":"Updates individual or multiple attributes of an existing resourcelink. At least one attribute has to be provided.","ref":"HueSDK.API.Resourcelinks.html#update_resourcelink/3","title":"HueSDK.API.Resourcelinks.update_resourcelink/3","type":"function"},{"doc":"Interface to the Rules API See the official documentation for more information.","ref":"HueSDK.API.Rules.html","title":"HueSDK.API.Rules","type":"module"},{"doc":"Creates a new rule in the bridge rule engine.","ref":"HueSDK.API.Rules.html#create_rule/2","title":"HueSDK.API.Rules.create_rule/2","type":"function"},{"doc":"Deletes the specified rule from the bridge.","ref":"HueSDK.API.Rules.html#delete_rule/2","title":"HueSDK.API.Rules.delete_rule/2","type":"function"},{"doc":"Gets a list of all rules that are in the bridge.","ref":"HueSDK.API.Rules.html#get_all_rules/1","title":"HueSDK.API.Rules.get_all_rules/1","type":"function"},{"doc":"Returns a rule object with id matching &lt;id&gt; or an error if &lt;id&gt; is not available.","ref":"HueSDK.API.Rules.html#get_rule_attributes/2","title":"HueSDK.API.Rules.get_rule_attributes/2","type":"function"},{"doc":"Updates a rule in the bridge rule engine.","ref":"HueSDK.API.Rules.html#update_rule/3","title":"HueSDK.API.Rules.update_rule/3","type":"function"},{"doc":"Interface to the Scenes API. See the official documentation for more information.","ref":"HueSDK.API.Scenes.html","title":"HueSDK.API.Scenes","type":"module"},{"doc":"Creates the given scene with all lights in the provided lights resource.","ref":"HueSDK.API.Scenes.html#create_scene/2","title":"HueSDK.API.Scenes.create_scene/2","type":"function"},{"doc":"Deletes a scene from the bridge.","ref":"HueSDK.API.Scenes.html#delete_scene/2","title":"HueSDK.API.Scenes.delete_scene/2","type":"function"},{"doc":"Gets a list of all scenes currently stored in the bridge.","ref":"HueSDK.API.Scenes.html#get_all_scenes/1","title":"HueSDK.API.Scenes.get_all_scenes/1","type":"function"},{"doc":"Gets the attributes of a given scene.","ref":"HueSDK.API.Scenes.html#get_scene_attributes/2","title":"HueSDK.API.Scenes.get_scene_attributes/2","type":"function"},{"doc":"Modifies or creates a new scene.","ref":"HueSDK.API.Scenes.html#modify_scene/3","title":"HueSDK.API.Scenes.modify_scene/3","type":"function"},{"doc":"Interface to the Schedules API See the official documentation for more information.","ref":"HueSDK.API.Schedules.html","title":"HueSDK.API.Schedules","type":"module"},{"doc":"Allows the user to create new schedules. The bridge can store up to 100 schedules.","ref":"HueSDK.API.Schedules.html#create_schedule/2","title":"HueSDK.API.Schedules.create_schedule/2","type":"function"},{"doc":"Deletes a schedule from the bridge.","ref":"HueSDK.API.Schedules.html#delete_schedule/2","title":"HueSDK.API.Schedules.delete_schedule/2","type":"function"},{"doc":"Gets a list of all schedules that have been added to the bridge.","ref":"HueSDK.API.Schedules.html#get_all_schedules/1","title":"HueSDK.API.Schedules.get_all_schedules/1","type":"function"},{"doc":"Gets all attributes for a schedule.","ref":"HueSDK.API.Schedules.html#get_schedule_attributes/2","title":"HueSDK.API.Schedules.get_schedule_attributes/2","type":"function"},{"doc":"Allows the user to change attributes of a schedule.","ref":"HueSDK.API.Schedules.html#set_schedule_attributes/3","title":"HueSDK.API.Schedules.set_schedule_attributes/3","type":"function"},{"doc":"Interface to the Sensors API. See the official documentation for more information.","ref":"HueSDK.API.Sensors.html","title":"HueSDK.API.Sensors","type":"module"},{"doc":"Allows the creation of sensors.","ref":"HueSDK.API.Sensors.html#create_sensor/2","title":"HueSDK.API.Sensors.create_sensor/2","type":"function"},{"doc":"All sensors can be deleted.","ref":"HueSDK.API.Sensors.html#delete_sensor/2","title":"HueSDK.API.Sensors.delete_sensor/2","type":"function"},{"doc":"Gets a list of all sensors that have been added to the bridge.","ref":"HueSDK.API.Sensors.html#get_all_sensors/1","title":"HueSDK.API.Sensors.get_all_sensors/1","type":"function"},{"doc":"Finds all new sensors since the last scan.","ref":"HueSDK.API.Sensors.html#get_new_sensors/1","title":"HueSDK.API.Sensors.get_new_sensors/1","type":"function"},{"doc":"Gets the sensor from the bridge with the given id.","ref":"HueSDK.API.Sensors.html#get_sensor_attributes/2","title":"HueSDK.API.Sensors.get_sensor_attributes/2","type":"function"},{"doc":"Starts a search for new sensors.","ref":"HueSDK.API.Sensors.html#search_for_new_sensors/1","title":"HueSDK.API.Sensors.search_for_new_sensors/1","type":"function"},{"doc":"The allowed configuration parameters depend on the sensor type.","ref":"HueSDK.API.Sensors.html#set_sensor_attributes/3","title":"HueSDK.API.Sensors.set_sensor_attributes/3","type":"function"},{"doc":"Renames the sensor in the bridge for the supplied id.","ref":"HueSDK.API.Sensors.html#set_sensor_name/3","title":"HueSDK.API.Sensors.set_sensor_name/3","type":"function"},{"doc":"Used to allow the state of a CLIP sensor to be updated.","ref":"HueSDK.API.Sensors.html#set_sensor_state/3","title":"HueSDK.API.Sensors.set_sensor_state/3","type":"function"},{"doc":"An unofficial Elixir SDK for the Philips Hue personal wireless lightning system. Build with Finch , Jason , Mdns , and NimbleOptions .","ref":"readme.html","title":"Elixir Hue SDK 💡","type":"extras"},{"doc":"HueSDK ships with the following features: Automatic discovery of the Hue Bridge device on local networks Complete support of the latest Hue Bridge JSON REST API SSL support for requests made to the Hue Bridge device Automatic Bridge Discovery HueSDK supports automatic bridge discovery via the following protocols: N-UPnP mDNS Manual IP If you have already connected your Hue Bridge device to the internet and registered online with Philips, then N-UPnP will be the fastest and most reliable way to discover your device. If you do not wish to connect your Hue Bridge device to the internet or register it with Philips, then mDNS can be used to discover your device. If neither of those protocols work, you can manually enter the IP address of your Hue Bridge device via the Manual IP protocol. Consult your home router to identify the device's IP address. REST API HueSDK supports the following resources: Lights Groups Schedules Scenes Sensors Rules Configuration Resourcelinks Capabilities Currently, this library provides a simple Elixir wrapper over the Hue Bridge REST API. Please refer to the official documentation for detailed information on interacting with lights, groups, schedules, etc. High-level Elixir APIs may be added in future versions. If you have any you would like implemented, please open an issue or pull-request!","ref":"readme.html#features","title":"Elixir Hue SDK 💡 - Features","type":"extras"},{"doc":"Add the Hue SDK to your mix.exs and run mix deps.get : def deps do [ { :hue_sdk , &quot;~&gt; 0.1.0&quot; } ] end Add any optional configuration to your config/*.exs files: use Config # disabling SSL config :hue_sdk , ssl : false # specifying a custom N-UPnP host config :hue_sdk , portal_host : &quot;mycustomproxy.com&quot;","ref":"readme.html#installation","title":"Elixir Hue SDK 💡 - Installation","type":"extras"},{"doc":"Automatically discover your Hue Bridge device available on your local network: { :nupnp , [ bridge ] } = HueSDK.Discovery . discover ( HueSDK.Discovery.NUPNP ) Press the link button on your Hue Bridge device and authenticate a new user: bridge = HueSDK.Bridge . authenticate ( bridge , &quot;connorlay#huesdk&quot; ) Make requests to the Hue Bridge REST API: HueSDK.API.Lights . get_all_lights ( bridge ) { :ok , %{ &quot;1&quot; =&gt; %{ &quot;capabilities&quot; =&gt; %{ &quot;certified&quot; =&gt; true , &quot;control&quot; =&gt; %{ &quot;colorgamut&quot; =&gt; [ [ 0.6915 , 0.3083 ] , [ 0.17 , 0.7 ] , [ 0.1532 , 0.0475 ] ] , &quot;colorgamuttype&quot; =&gt; &quot;C&quot; , &quot;ct&quot; =&gt; %{ &quot;max&quot; =&gt; 500 , &quot;min&quot; =&gt; 153 } , &quot;maxlumen&quot; =&gt; 800 , &quot;mindimlevel&quot; =&gt; 200 } , &quot;streaming&quot; =&gt; %{ &quot;proxy&quot; =&gt; true , &quot;renderer&quot; =&gt; true } } , &quot;config&quot; =&gt; %{ &quot;archetype&quot; =&gt; &quot;classicbulb&quot; , &quot;direction&quot; =&gt; &quot;omnidirectional&quot; , &quot;function&quot; =&gt; &quot;mixed&quot; , &quot;startup&quot; =&gt; %{ &quot;configured&quot; =&gt; true , &quot;mode&quot; =&gt; &quot;safety&quot; } } , &quot;manufacturername&quot; =&gt; &quot;Signify Netherlands B.V.&quot; , &quot;modelid&quot; =&gt; &quot;LCA003&quot; , &quot;name&quot; =&gt; &quot;Floor Lamp&quot; , &quot;productid&quot; =&gt; &quot;Philips-LCA003-1-A19ECLv6&quot; , &quot;productname&quot; =&gt; &quot;Hue color Lamp&quot; , &quot;state&quot; =&gt; %{ &quot;alert&quot; =&gt; &quot;select&quot; , &quot;bri&quot; =&gt; 145 , &quot;colormode&quot; =&gt; &quot;xy&quot; , &quot;ct&quot; =&gt; 443 , &quot;effect&quot; =&gt; &quot;none&quot; , &quot;hue&quot; =&gt; 7675 , &quot;mode&quot; =&gt; &quot;homeautomation&quot; , &quot;on&quot; =&gt; false , &quot;reachable&quot; =&gt; true , &quot;sat&quot; =&gt; 199 , &quot;xy&quot; =&gt; [ 0.5016 , 0.4151 ] } , &quot;swconfigid&quot; =&gt; &quot;598716A0&quot; , &quot;swupdate&quot; =&gt; %{ &quot;lastinstall&quot; =&gt; &quot;2021-01-27T22:48:41&quot; , &quot;state&quot; =&gt; &quot;noupdates&quot; } , &quot;swversion&quot; =&gt; &quot;1.76.6&quot; , &quot;type&quot; =&gt; &quot;Extended color light&quot; , &quot;uniqueid&quot; =&gt; &quot;00:17:88:01:09:4c:a7:29-0b&quot; } , # ... } }","ref":"readme.html#usage","title":"Elixir Hue SDK 💡 - Usage","type":"extras"},{"doc":"The Hue Developers forum . The Hue API documentation .","ref":"readme.html#additional-resources","title":"Elixir Hue SDK 💡 - Additional Resources","type":"extras"},{"doc":"To the authors of Huex and Yet Another Hue API , which served as inspiration for HueSDK . To the maintainers of Finch , Jason , Mdns , and NimbleOptions for their ongoing efforts. To Philips and Signify for creating the Hue Lighting system and opening the REST API for developers.","ref":"readme.html#acknowledgments","title":"Elixir Hue SDK 💡 - Acknowledgments","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Connor Lay (Clay) Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"First version released! Hue REST API Adds Capabilities API Adds Configuration API Adds Groups API Adds Lights API Adds Resourcelinks API Adds Rules API Adds Scenes API Adds Schedules API Adds Sensors API Hue Bridge Discovery Adds N-UPnP Adds mDNS Adds Manual IP Misc. Adds SSL support","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"Welcome! If you are interested in contributing, please read this document.","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Like Elixir itself, this project treats documentation as a first-class citizen. Documentation is generated with ExDoc and hosted on HexDocs . Guides are written in Markdown and added as extra pages to ExDoc. To learn more, please read Writing Documentation . All public functions and modules should be documented with @moduledoc and @doc . All public functions and structs should have their types specified with @spec and @type . Typespecs are validated with Dialyxir . To learn more, please read the Typespecs documentation .","ref":"contributing.html#documentation","title":"Contributing - Documentation","type":"extras"},{"doc":"Credo is used as the code linter for this project. All Elixir source code is formatted with the official code formatter . Tests are executed with ExUnit . Tests involving an actual HTTP server utilize Bypass . Mocks for Elixir Behaviours are created with Mox . Line coverage is generated with Erlang's cover module .","ref":"contributing.html#linting-testing","title":"Contributing - Linting &amp; Testing","type":"extras"},{"doc":"GitHub Actions are used for continuous integration. Pull requests will only be merged once approved and pass all CI checks. This projects follows Semantic Versioning . Releases are tagged in GitHub and published to Hex.pm .","ref":"contributing.html#continuous-integration-publishing","title":"Contributing - Continuous Integration &amp; Publishing","type":"extras"}]